package dev.shadowsoffire.apotheosis.adventure.client;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.adventure.client.AdventureModuleClient;
import dev.shadowsoffire.apotheosis.adventure.client.BossSpawnMessage;
import dev.shadowsoffire.placebo.network.MessageHelper;
import dev.shadowsoffire.placebo.network.MessageProvider;
import java.util.Optional;
import java.util.function.Supplier;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraftforge.network.NetworkDirection;
import net.minecraftforge.network.NetworkEvent;

public class Provider implements MessageProvider<BossSpawnMessage> {
  public Class<?> getMsgClass() {
    return BossSpawnMessage.class;
  }
  
  public void write(BossSpawnMessage msg, FriendlyByteBuf buf) {
    buf.m_130064_(msg.pos);
    buf.writeInt(msg.color);
  }
  
  public BossSpawnMessage read(FriendlyByteBuf buf) {
    return new BossSpawnMessage(buf.m_130135_(), buf.readInt());
  }
  
  public void handle(BossSpawnMessage msg, Supplier<NetworkEvent.Context> ctx) {
    MessageHelper.handlePacket(() -> AdventureModuleClient.onBossSpawn(msg.pos, toFloats(msg.color)), ctx);
  }
  
  public Optional<NetworkDirection> getNetworkDirection() {
    return Optional.of(NetworkDirection.PLAY_TO_CLIENT);
  }
  
  private static float[] toFloats(int color) {
    float[] arr = new float[3];
    arr[0] = (color >> 16 & 0xFF) / 255.0F;
    arr[1] = (color >> 8 & 0xFF) / 255.0F;
    arr[2] = (color & 0xFF) / 255.0F;
    return arr;
  }
}
